import lark_oapi as lark
import json
import pandas as pd
import re
## P2ImMessageReceiveV1 为接收消息 v2.0；CustomizedEvent 内的 message 为接收消息 v1.0。
def do_p2_im_message_receive_v1(data: lark.im.v1.P2ImMessageReceiveV1) -> None:
    print(f'[ do_p2_im_message_receive_v1 access ], data: {lark.JSON.marshal(data, indent=4)}')
    cur_message = data.event.message
    json_content = json.loads(cur_message.content)
 
    print("json_content=",  json_content)
    content = json_content["text"]
    if "@_user_1" not in content:
        return
    content =content.replace("@_user_1","")
    content =content.strip()
    action_type = None
    content =content.lower()

    if "pass" in  content:
        action_type = "remove"
        content = content.replace("pass","")
        content = content.strip()
    if content =="":
        return
    arr_str_tokenaddress =re.split(r'\s+', content)  
    print("arr_str_tokenaddress=",  arr_str_tokenaddress)
    if action_type == "remove":
        remove_df = pd.DataFrame( arr_str_tokenaddress, columns=["remove_tokenaddress"] )
        if os.path.exists(f"/root/Desktop/gendan/remove_df.csv" ):
            remove_df.to_csv(f"/root/Desktop/gendan/remove_df.csv",  mode='a',header =False , index = False  )
        else:
            remove_df.to_csv(f"/root/Desktop/gendan/remove_df.csv",  index = False  )



event_handler = lark.EventDispatcherHandler.builder("", "") \
    .register_p2_im_message_receive_v1(do_p2_im_message_receive_v1) \
    .build()



 

def main():
    cli = lark.ws.Client("cli_a65709e678ba100b", "Ny72zT3n4jL6JwnJ2nyCCcvNbNt421MR",
                         event_handler=event_handler,
                         log_level=lark.LogLevel.DEBUG)
    cli.start()

if __name__ == "__main__":
    main()