
const web3 = require('@solana/web3.js');
const fs = require("fs-extra");
const BigNumber = require("bignumber.js");
const { Wallet } = require('@coral-xyz/anchor');
const Decimal = require('decimal.js');
const BN = require('bn.js');
const cron = require('node-cron');
const bs58 = require('bs58')
const raydium_sdk = require("@raydium-io/raydium-sdk");
const deepcopy = require('deepcopy');
const clear = require('clear');
const Config = require("./config")
const axios = require('axios');

let jsonInfo2PoolKeys = raydium_sdk.jsonInfo2PoolKeys;


let log = console.log;
console.log = function () {
  let args = Array.from(arguments);
  let log_prefix = new Date().toISOString();
  args.unshift(log_prefix + "");
  log.apply(console, args);
}
BigInt.prototype.toJSON = function () {
  return this.toString()
}


//定时任务每秒执行一次
let crontask;
let obj_dalaoAddress_2_arrdalao = Config.obj_dalaoAddress_2_arrdalao;
let mywalletaddress = Config.mywalletaddress;
let walletPrivateKey = Config.mywalletPrivateKey;
let Liquidity = raydium_sdk.Liquidity;
let LiquidityPoolKeys = raydium_sdk.LiquidityPoolKeys;
let Percent = raydium_sdk.Percent;
let Token = raydium_sdk.Token;
let TokenAmount = raydium_sdk.TokenAmount;
let CurrencyAmount = raydium_sdk.CurrencyAmount;
let ApiPoolInfoV4 = raydium_sdk.ApiPoolInfoV4;
let LIQUIDITY_STATE_LAYOUT_V4 = raydium_sdk.LIQUIDITY_STATE_LAYOUT_V4;
let MARKET_STATE_LAYOUT_V3 = raydium_sdk.MARKET_STATE_LAYOUT_V3;
let Market = raydium_sdk.Market;
let SPL_MINT_LAYOUT = raydium_sdk.SPL_MINT_LAYOUT;
let listen_axios_config = Config.listen_axios_config;

let Keypair = web3.Keypair;
let PublicKey = web3.PublicKey;

let obj_mine_pendingtxhash_2_dalaoinfo = Config.obj_mine_pendingtxhash_2_dalaoinfo;
let wallet = new Wallet(Keypair.fromSecretKey(Uint8Array.from(bs58.decode(walletPrivateKey))))




let dalaobuytokenscounts_obj = {};
let obj_sellFailedInfo = {};
// let obj_dalaoCheckStatus = {}; //dalao的状态 dalao -->[] 如何数组为空数组 说明没有对其进行tx分析 如果[true] 说明在进行分析 有一个true 就是在分析一个tx
// 遍历全部dalao的第一个address 即obj_dalaoAddress_2_arrdalao的key
for (let dalaoAddress of Object.keys(obj_dalaoAddress_2_arrdalao)) {

  dalaobuytokenscounts_obj[dalaoAddress] = {};
  // obj_dalaoCheckStatus[dalaoAddress] = [];
}

const buySolAmount0_02 = BigInt(0.02 * 10 ** 9);
const buySolAmount0_1 = BigInt(0.1 * 10 ** 9);
const buySolAmount0_2 = BigInt(0.2 * 10 ** 9);
const buySolAmount0_00001 = BigInt(0.00001 * 10 ** 9);


let arr_total_str_dalaoAddress_forlisten = Config.arr_total_str_dalaoAddress_forlisten;
// let arr_total_web3pub_dalaoAddress_forlisten = Config.arr_total_web3pub_dalaoAddress_forlisten;
let len_arr_total_dalaoAddress = Config.len_arr_total_dalaoAddress;
let obj_dalao_existtxhash_2_set = Config.obj_dalao_existtxhash_2_set
let obj_dalao_isbusy = Config.obj_dalao_isbusy;



function parsedtransactionAndfindammid(obj_transaction, str_dalao_address) {


  let arr_staticAccountKeys = obj_transaction.transaction.message.staticAccountKeys;
  arr_staticAccountKeys.forEach((val, index, arr) => arr[index] = val.toBase58());
  let arr_readonly = obj_transaction.meta.loadedAddresses.readonly;
  arr_readonly.forEach((val, index, arr) => arr[index] = val.toBase58());
  let arr_writable = obj_transaction.meta.loadedAddresses.writable;
  arr_writable.forEach((val, index, arr) => arr[index] = val.toBase58());
  arr_staticAccountKeys = [...arr_staticAccountKeys, ...arr_writable, ...arr_readonly];
  let arr_transaction_transaction_message_instructions = obj_transaction.transaction.message.compiledInstructions;
  if (arr_transaction_transaction_message_instructions == undefined) {
    return undefined;
  }
  let obj_swap_instructions = {}
  obj_transaction["obj_swap_instructions"] = obj_swap_instructions;

  for (let idx_instructions = 0; idx_instructions < arr_transaction_transaction_message_instructions.length; idx_instructions++) {

    // 要添加一个 Jupiter Aggregator V6 的判断 因为调用了 Jupiter不会再transaction中出现raydium

    let obj_instruction = arr_transaction_transaction_message_instructions[idx_instructions];
    let number_programIdIndex = obj_instruction.programIdIndex;
    let program = arr_staticAccountKeys[number_programIdIndex];
    let arr_accountKeyIndexes = obj_instruction.accountKeyIndexes;

    // console.log("arr_accountKeyIndexes=", arr_accountKeyIndexes.length)

    if (arr_accountKeyIndexes.length == 18) {
      arr_accountKeyIndexes.forEach((val, index, arr) => {
        arr[index] = arr_staticAccountKeys[val];
      });
      if (arr_accountKeyIndexes[0] != "TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA" || arr_accountKeyIndexes[2] != "5Q544fKrFoe6tsEbD7S8EmxGTJYAKtTVhAW5Q5pge4j1") {
        // 不是raydium 的toekntransfer 跳过
        continue;
      }
      let str_ammid = arr_accountKeyIndexes[1];
      obj_swap_instructions[str_ammid] = str_ammid;
      continue;
    }
    if (program != "JUP6LkbZbjS1jKKwapdHNy74zcZ3tLUZoi5QNyVTaV4") {
      continue;
    }
    arr_accountKeyIndexes.forEach((val, index, arr) => {
      arr[index] = arr_staticAccountKeys[val];
    });
    if (arr_accountKeyIndexes[0] != "TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA") {
      continue
    }
    let Raydium_Authority_V4_pos = arr_accountKeyIndexes.indexOf("5Q544fKrFoe6tsEbD7S8EmxGTJYAKtTVhAW5Q5pge4j1");
    if (Raydium_Authority_V4_pos == -1) {
      continue;
    }
    let str_ammid = arr_accountKeyIndexes[Raydium_Authority_V4_pos - 1];
    obj_swap_instructions[str_ammid] = str_ammid;
    continue;
    // SharedAccountsRoute
    // if (arr_accountKeyIndexes[0] == "TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA" && arr_accountKeyIndexes[12] && arr_accountKeyIndexes[12] == "JUP6LkbZbjS1jKKwapdHNy74zcZ3tLUZoi5QNyVTaV4") {
    //   // Jupiter Aggregator V6: SharedAccountsRoute
    // }
    // else if (arr_accountKeyIndexes[0] == "TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA" && arr_accountKeyIndexes[13] && arr_accountKeyIndexes[13] == "JUP6LkbZbjS1jKKwapdHNy74zcZ3tLUZoi5QNyVTaV4") {
    //   // Jupiter Aggregator V6: sharedAccountsRouteWithTokenLedger
    // } else if (arr_accountKeyIndexes[0] == "TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA" && arr_accountKeyIndexes[13] && arr_accountKeyIndexes[8] == "JUP6LkbZbjS1jKKwapdHNy74zcZ3tLUZoi5QNyVTaV4") {
    //   // Jupiter Aggregator V6:  route
    // }

  }

  return obj_transaction;

}





async function buyToken({
  dalao_address,
  sign,
  str_maintoken_address,
  str_swaptoken_address,
  str_ammid,
  number_maintoken_decimals,
  number_swaptoken_decimals,
  bigint_actual_swapinamount,
  bigint_expect_swapminoutamount,
  arr_walletTokenAccount,
  wallet,
  arr_one_walletTokenAccount,
  number_dalao_fee,
  number_dalao_computeUnitsConsumed,

} = {}) {
  console.log(`enter buyToken dalao_address=${dalao_address} str_swaptoken_address=${str_swaptoken_address} sign=${sign} buysolamount=${bigint_actual_swapinamount}`);

  let amm_pool_info = obj_total_ammpool[str_ammid];
  let poolkeys = jsonInfo2PoolKeys(amm_pool_info);
  let inputToken = Token.WSOL;
  // let inputToken = new Token(raydium_sdk.TOKEN_PROGRAM_ID, new PublicKey(str_maintoken_address), number_maintoken_decimals, 'SOL', 'SOL');
  let outputToken = new Token(raydium_sdk.TOKEN_PROGRAM_ID, new PublicKey(str_swaptoken_address), number_swaptoken_decimals, 'TOKEN', 'TOKEN');

  let inputTokenAmount = new raydium_sdk.TokenAmount(inputToken, bigint_actual_swapinamount);
  let minAmountOutRaw = bigint_expect_swapminoutamount;
  let minAmountOut = new TokenAmount(outputToken, minAmountOutRaw);
  // let minAmountOut =
  //   outputToken instanceof Token
  //     ? new TokenAmount(outputToken, minAmountOutRaw)
  //     : new CurrencyAmount(outputToken, minAmountOutRaw)

  let number_mine_uints = 200000;
  let number_mine_microLamports = 1000000;
  if (number_dalao_computeUnitsConsumed <= 100000) {
    number_mine_uints = 130000;
  }
  else if (number_dalao_computeUnitsConsumed < 133333) {
    number_mine_uints = parseInt(number_dalao_computeUnitsConsumed * 1.3);
  } else {
    number_mine_uints = 200000;
  }
  // else if (number_dalao_computeUnitsConsumed <= 220000) {
  //   number_mine_uints = 200000;
  // }
  // else if (number_dalao_computeUnitsConsumed < 250000) {
  //   number_mine_uints = parseInt(number_dalao_computeUnitsConsumed * 1.3);
  // } else {
  //   number_mine_uints = 300000;
  // }

  number_mine_microLamports = parseInt((number_dalao_fee - 5000) / number_mine_uints * 1e6);
  if (number_mine_microLamports <= 1000000) {
    //   1e6  1个lamports
    //   number_mine_microLamports = 2000000;
    // } else if (number_mine_microLamports <= 2000000) {
    number_mine_microLamports = 3100000;
  } else if (number_mine_microLamports <= 3000000) {
    number_mine_microLamports = 4300000;
  } else if (number_mine_microLamports <= 4000000) {
    number_mine_microLamports = 5300000;
  } else if (number_mine_microLamports <= 6000000) {
    number_mine_microLamports = 6300000;
  } else {
    number_mine_microLamports = 7300000;
  }


  // -------- step 2: create instructions by SDK function --------
  let obj_makeSwapInstructionSimple_param = {
    connection: swap_connection,
    poolKeys: poolkeys,
    userKeys: {
      tokenAccounts: arr_one_walletTokenAccount,
      owner: wallet.publicKey,
    },
    amountIn: inputTokenAmount,
    amountOut: minAmountOut,
    fixedSide: 'in',
    makeTxVersion: raydium_sdk.TxVersion.V0,
    computeBudgetConfig: {
      // units: number_mine_uints,
      microLamports: number_mine_microLamports,

    },
  }



  // // ,,,,,模拟买入
  // await sleep(3000);
  // let map_pendingSellToken_value = map_pendingSellToken.get(str_swaptoken_address);
  // let obj_dalaoInfo = map_pendingSellToken_value.obj_total_dalaoInfo[dalao_address];
  // obj_dalaoInfo.bigint_myTokenAmount = obj_dalaoInfo.bigint_myTokenAmount + 1000n;

  // console.log(`dalao_address=${dalao_address} sign=${sign} buysolamount=${bigint_actual_swapinamount} bigint_myTokenAmount=${obj_dalaoInfo.bigint_myTokenAmount} buyToken Success`);
  // //计算购买价格
  // let str_cur_buyprice = "0.001"
  // if (accDiv(obj_dalaoInfo.str_maxbuyprice, str_cur_buyprice) < 1) {
  //   obj_dalaoInfo.str_maxbuyprice = str_cur_buyprice;
  // }

  // savePendingSellTokens();
  // saveTotalAmmpool();
  // updateWalletTokenAccount();
  // saveWalletTokenAccount();

  // return;

  // //真实买入

  let obj_res_transaction = await buildAndsend(obj_makeSwapInstructionSimple_param, "buytoken", dalao_address, str_swaptoken_address);
  if (obj_res_transaction == undefined) {
    // dalaobuytokenscounts_obj[dalao_address][str_swaptoken_address]['buyCounts']--;
    return;
  }



  //买入成功 更新数据
  // let obj_res_transaction = await swap_connection.getTransaction(res_sign, { commitment: "confirmed", maxSupportedTransactionVersion: 0 });
  let [my_spl_dict, router_sol_dict, router_spl_dict] = get_dalaoArouter_changes_info(mywalletaddress, obj_res_transaction);
  let dalao_spl_idx = my_spl_dict.mint.indexOf(str_swaptoken_address);
  if (dalao_spl_idx == -1) {
    console.log(`warning dalao_spl_idx==-1`);
    return;
  }

  let map_pendingSellToken_value = map_pendingSellToken.get(str_swaptoken_address);
  let obj_dalaoInfo = map_pendingSellToken_value.obj_total_dalaoInfo[dalao_address];
  let bigint_my_spl_balance_changes = my_spl_dict.balance_changes[dalao_spl_idx];
  let bigint_my_spl_postbalance = my_spl_dict.prepost_balances[dalao_spl_idx][1];
  let bigint_my_sol_balance_changes = -router_sol_dict.balance_changes[0];


  obj_dalaoInfo.bigint_myTokenAmount = obj_dalaoInfo.bigint_myTokenAmount + bigint_my_spl_balance_changes;

  console.log(`dalao_address=${dalao_address} str_swaptoken_address=${str_swaptoken_address} sign=${sign} buysolamount=${bigint_actual_swapinamount} bigint_myTokenAmount=${obj_dalaoInfo.bigint_myTokenAmount} buyToken Success 买入成功`);

  //计算购买价格
  let str_cur_buyprice = accDiv(bigint_my_spl_balance_changes, -bigint_my_sol_balance_changes);
  if (accDiv(obj_dalaoInfo.str_maxbuyprice, str_cur_buyprice) < 1) {
    obj_dalaoInfo.str_maxbuyprice = str_cur_buyprice;
  }
  savePendingSellTokens();
  saveTotalAmmpool();
  if (arr_one_walletTokenAccount.length == 0) {
    // let arr_onewallet = await updateWalletTokenAccount(str_swaptoken_address);
    // map_pendingSellToken_value.str_ata = arr_onewallet[0].pubkey.toBase58();
    let retry_times = 15;
    while (retry_times > 0) {
      retry_times--;
      let arr_onewallet = await getoneWalletTokenAccount(wallet.publicKey, str_swaptoken_address);
      if (arr_onewallet.length != 0) {
        map_pendingSellToken_value.str_ata = arr_onewallet[0].pubkey.toBase58();
      } else {
        await sleep(1200);
        continue
      }
    }


  }

  save_obj_dalao_existtxhash_2_set();
  return;

}

async function buildAndsend(obj_makeSwapInstructionSimple_param, swaptype, str_dalao_address, str_swaptoken_address) {
  let { innerTransactions } = await Liquidity.makeSwapInstructionSimple(obj_makeSwapInstructionSimple_param);
  let latestBlockHash;
  latestBlockHash = await swap_connection.getLatestBlockhash("confirmed");
  console.log("latestBlockHash=", latestBlockHash);
  const instructions = innerTransactions[0].instructions.filter(Boolean);
  const versionedTransaction = new web3.VersionedTransaction(
    new web3.TransactionMessage({
      payerKey: wallet.publicKey,
      recentBlockhash: latestBlockHash.blockhash,
      instructions: instructions,
    }).compileToV0Message()
  )
  // //模拟卖出
  // await sleep(3000);
  // obj_dalaoInfo.bigint_myTokenAmount = obj_dalaoInfo.bigint_myTokenAmount - bigint_AmountIn;
  // console.log(`dalao_address=${dalao_address} str_swaptoken_address=${str_swaptoken_address} sign=${sign} sellToken Success`);
  // return;
  // // 真实卖出
  versionedTransaction.sign([wallet.payer]);
  let serializeTransaction = versionedTransaction.serialize();
  let res_sign;
  try {
    res_sign = await sendtransactiion_connection.sendRawTransaction(serializeTransaction, {
      skipPreflight: true,
      maxRetries: 3,
    });
  } catch (e) {
    console.log("sendRawTransaction error", e.message)
    if (e.message.indexOf("Blockhash not found") != -1 || e.message.indexOf("block height exceeded") != -1) {
      let res = await buildAndsend(obj_makeSwapInstructionSimple_param, swaptype, str_dalao_address, str_swaptoken_address);
      return res;

    }
  }

  console.log(`buildAndsend_() has sendtransaction str_dalao_address=${str_dalao_address} res_sign=${res_sign}`);
  await sleep(2000);
  let obj_res_transaction;
  try {
    obj_res_transaction = await multimes_getTransaction(res_sign);
  } catch (e) {
    console.log(`buildAndsend_() str_dalao_address=${str_dalao_address} str_swaptoken_address=${str_swaptoken_address} res_sign=${res_sign} ${e.message}`)
    return;
  }
  let meta_err = obj_res_transaction.meta.err;
  if (meta_err != null) {
    console.log(`buildAndsend_() tx unsuccessful res_sign=${res_sign}`);
    obj_mine_pendingtxhash_2_dalaoinfo[res_sign] = { "str_dalao_address": str_dalao_address, "str_swaptoken_address": str_swaptoken_address };
    return;
  }
  console.log(`buildAndsend_() ${swaptype} success str_dalao_address=${str_dalao_address} str_swaptoken_address=${str_swaptoken_address} res_sing=${res_sign}`);
  return obj_res_transaction;
}

async function sellToken({
  dalao_address,
  sign,
  str_swapintoken,
  str_swapouttoken,
  str_ammid,
  number_decimals_swapintoken,
  number_decimals_swapouttoken,
  arr_walletTokenAccount,
  wallet,
  obj_someinfo
} = {}) {


  let str_maintoken_address = str_swapouttoken;
  let str_swaptoken_address = str_swapintoken;
  let number_maintoken_decimals = number_decimals_swapouttoken;
  let number_swaptoken_decimals = number_decimals_swapintoken;
  let number_dalao_fee = obj_someinfo.number_dalao_fee;
  let number_dalao_computeUnitsConsumed = obj_someinfo.number_dalao_computeUnitsConsumed;

  console.log(`enter sellToken dalao_address=${dalao_address} str_swaptoken_address=${str_swaptoken_address} sign=${sign} `);
  // -------- pre-action: get pool info --------
  let amm_pool_info = obj_total_ammpool[str_ammid];

  // let amm_pool_info = await formatAmmKeysById(str_ammid);
  let poolkeys = jsonInfo2PoolKeys(amm_pool_info);
  let inputToken = new Token(raydium_sdk.TOKEN_PROGRAM_ID, new PublicKey(str_swaptoken_address), number_swaptoken_decimals, 'TOKEN', 'TOKEN');
  // let outputToken = new Token(raydium_sdk.TOKEN_PROGRAM_ID, new PublicKey(str_maintoken_address), number_maintoken_decimals, 'SOL', 'SOL');
  let outputToken = Token.WSOL;
  let map_pendingSellToken_value = map_pendingSellToken.get(str_swaptoken_address);
  if (map_pendingSellToken_value == undefined) {
    console.log(`NotSell dalao_address=${dalao_address} str_swaptoken_address=${str_swaptoken_address} map_pendingSellToken_value is undefined`);
    return;
  }
  let obj_dalaoInfo = map_pendingSellToken_value.obj_total_dalaoInfo[dalao_address];
  if (obj_dalaoInfo == undefined) {
    console.log(`NotSell dalao_address=${dalao_address} str_swaptoken_address=${str_swaptoken_address} obj_dalaoInfo is undefined`);
    return;
  }
  if (obj_dalaoInfo.bigint_myTokenAmount == 0n) {
    console.log(`NotSell dalao_address=${dalao_address} str_swaptoken_address=${str_swaptoken_address} obj_dalaoInfo.bigint_myTokenAmount=0`);
    return;

  }

  obj_dalaoInfo.bigint_dalaoToken_NowAmount = obj_someinfo.bigint_dalaoToken_NowAmount;

  let number_sellpercent = Number((-obj_someinfo.bigint_dalaoToken_NowAmount + obj_someinfo.bigint_dalaoToken_PreAmount) * 100n / obj_someinfo.bigint_dalaoToken_PreAmount) / 100;

  if (number_sellpercent <= 0.1) {
    console.log(`NotSell dalao_address=${dalao_address} str_swaptoken_address=${str_swaptoken_address} sign=${sign} NotSellToken number_sellpercent too low`)
    return;
  } else if (number_sellpercent >= 0.7) {
    console.log(`dalao_address=${dalao_address} str_swaptoken_address=${str_swaptoken_address} sign=${sign} number_sellpercent convertto 1`)
    number_sellpercent = 1;

  }
  let bigint_AmountIn = BigInt(number_sellpercent * 100) * obj_dalaoInfo.bigint_myTokenAmount / 100n;
  let inputTokenAmount = new raydium_sdk.TokenAmount(inputToken, bigint_AmountIn);

  console.log(`sellToken dalao_address=${dalao_address} sign=${sign} token=${str_swaptoken_address} Amount=${inputTokenAmount.toFixed()}`);

  let minAmountOutRaw = 1n;
  let minAmountOut = new TokenAmount(outputToken, minAmountOutRaw);
  // let minAmountOut =
  //   outputToken instanceof Token
  //     ? new TokenAmount(outputToken, minAmountOutRaw)
  //     : new CurrencyAmount(outputToken, minAmountOutRaw)



  let str_ata = map_pendingSellToken_value.str_ata;
  let arr_one_walletTokenAccount = [];
  if (str_ata != undefined) {
    arr_one_walletTokenAccount = [{
      "pubkey": new web3.PublicKey(str_ata),
      "programId": new web3.PublicKey("TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA"),
      "accountInfo": {
        "mint": new web3.PublicKey(str_swapintoken),
        "owner": new PublicKey(mywalletaddress),
        "amount": new BN("11111111111", 16),
        "delegateOption": 0,
        "delegate": new web3.PublicKey("11111111111111111111111111111111"),
        "state": 1,
        "isNativeOption": 0,
        "isNative": new BN("00", 16),
        "delegatedAmount": new BN("00", 16),
        "closeAuthorityOption": 0,
        "closeAuthority": new web3.PublicKey("11111111111111111111111111111111")
      }
    }]

  } else {
    console.log("selltoken str_ata=undefined");
    arr_one_walletTokenAccount = arr_walletTokenAccount;

  }


  let number_mine_uints = 200000;
  let number_mine_microLamports = 1000000;
  if (number_dalao_computeUnitsConsumed <= 100000) {
    number_mine_uints = 130000;
  }
  else if (number_dalao_computeUnitsConsumed < 133333) {
    number_mine_uints = parseInt(number_dalao_computeUnitsConsumed * 1.3);
  } else {
    number_mine_uints = 200000;
  }

  // else if (number_dalao_computeUnitsConsumed <= 220000) {
  //   number_mine_uints = 200000;
  // }
  // else if (number_dalao_computeUnitsConsumed < 250000) {
  //   number_mine_uints = parseInt(number_dalao_computeUnitsConsumed * 1.3);
  // } else {
  //   number_mine_uints = 300000;

  // }

  number_mine_microLamports = parseInt((number_dalao_fee - 5000) / number_mine_uints * 1e6);
  if (number_mine_microLamports <= 1000000) {
    //   1e6  1个lamports
    //   number_mine_microLamports = 2000000;
    // } else if (number_mine_microLamports <= 2000000) {
    number_mine_microLamports = 3100000;
  } else if (number_mine_microLamports <= 3000000) {
    number_mine_microLamports = 4300000;
  } else if (number_mine_microLamports <= 4000000) {
    number_mine_microLamports = 5300000;
  } else if (number_mine_microLamports <= 6000000) {
    number_mine_microLamports = 6300000;
  } else {
    number_mine_microLamports = 7300000;

  }


  // -------- step 2: create instructions by SDK function --------
  let obj_makeSwapInstructionSimple_param = {
    connection: swap_connection,
    poolKeys: poolkeys,
    userKeys: {
      tokenAccounts: arr_one_walletTokenAccount,
      owner: wallet.publicKey,
    },
    amountIn: inputTokenAmount,
    amountOut: minAmountOut,
    fixedSide: 'in',
    makeTxVersion: raydium_sdk.TxVersion.V0,
    computeBudgetConfig: {
      // units: number_mine_uints,
      microLamports: number_mine_microLamports,

    },
  }

  // 如果不成功 在卖一次两次还不成功就算了
  let obj_res_transaction = await buildAndsend(obj_makeSwapInstructionSimple_param, "selltoken", dalao_address, str_swaptoken_address);
  if (obj_res_transaction == undefined) {
    obj_makeSwapInstructionSimple_param['computeBudgetConfig']['microLamports'] = parseInt(number_mine_microLamports * 1.3);
    obj_res_transaction = await buildAndsend(obj_makeSwapInstructionSimple_param, "selltoken", dalao_address, str_swaptoken_address);

  }
  if (obj_res_transaction == undefined) {
    return;
  }

  // dalaobuytokenscounts_obj[dalao_address][str_swaptoken_address]['buyCounts']--;



  // //卖出成功 更新数据
  // let obj_res_transaction = await swap_connection.getTransaction(res_sign, { commitment: "confirmed", maxSupportedTransactionVersion: 0 });
  let [my_spl_dict, router_sol_dict, router_spl_dict] = get_dalaoArouter_changes_info(mywalletaddress, obj_res_transaction);
  let dalao_spl_idx = my_spl_dict.mint.indexOf(str_swaptoken_address);
  if (dalao_spl_idx == -1) {
    console.log(`warning dalao_spl_idx==-1`);
    //拉黑
    sellFailStatistics({
      "tokenAddress": str_swaptoken_address,
      "pendingSellToken": map_pendingSellToken_value
    })
    return;
  }

  let bigint_my_spl_balance_changes = my_spl_dict.balance_changes[dalao_spl_idx];
  let bigint_my_spl_postbalance = my_spl_dict.prepost_balances[dalao_spl_idx][1];
  let bigint_my_sol_balance_changes = -router_sol_dict.balance_changes[0];
  obj_dalaoInfo.bigint_myTokenAmount = obj_dalaoInfo.bigint_myTokenAmount - bigint_AmountIn;

  console.log(`sellToken dalao_address=${dalao_address} str_swaptoken_address=${str_swaptoken_address} token=${str_swaptoken_address} bigint_my_sol_balance_changes=${Number(bigint_my_sol_balance_changes) / 1e9} `);

  //计算卖出价格 防止貔貅被坑
  // let str_cur_sellprice = accDiv(-bigint_my_spl_balance_changes, bigint_my_sol_balance_changes);
  // if (accDiv(obj_dalaoInfo.str_maxbuyprice, str_cur_sellprice) >= 8) {
  //价格差距过大 拉黑
  // sellFailStatistics({
  //   "tokenAddress": str_swaptoken_address,
  //   "pendingSellToken": map_pendingSellToken_value
  // })
  // }

  savePendingSellTokens();
  saveTotalAmmpool();
  await updateWalletTokenAccount();
  saveWalletTokenAccount();
  save_obj_dalao_existtxhash_2_set();
  return;



}


function getTimeMinDiff(startDateNow, endDateNow) {
  let timeDiff = endDateNow - startDateNow;  // 时间差的毫秒数
  let min = Math.floor(timeDiff / (60 * 1000)); // 计算出分钟
  return min;
};

function saveTotalAmmpool() {
  try {
    fs.writeJSONSync('total_ammpool.json', obj_total_ammpool, { spaces: 4 });
    console.log('save_total_ammpool success');
  } catch (error) {
    console.log('save_total_ammpool error=', error.message);
  }
}


function saveWalletTokenAccount() {
  try {

    fs.writeJSONSync('arr_walletTokenAccount.json', arr_walletTokenAccount, { spaces: 4 });
    console.log('saveWalletTokenAccount success');

  } catch (error) {
    console.log('saveWalletTokenAccount error error=', error.message);
  }
}




//初始化文本中的代卖出代币信息
function initPendingSellTokens() {
  try {
    // let data;
    //同步的方式读取文件
    if (!fs.existsSync('pendingSellToken.json')) {

      console.log("初始化待卖出代币信息成功");
      return;
    }
    map_pendingSellToken = fs.readJSONSync('pendingSellToken.json', { encoding: 'utf8', flag: 'r' });
    // data = JSON.parse(data);
    //还原 
    map_pendingSellToken = new Map(Object.entries(map_pendingSellToken));
    if (map_pendingSellToken.size > 0) {
      //遍历
      // for (const [tokenAddress, map_pendingSellToken_value ] of map_pendingSellToken) {
      //检测当前是否还持有 此token
      for (let obj_walletTokenAccount of arr_walletTokenAccount) {
        let token_address = obj_walletTokenAccount.accountInfo.mint.toBase58();

        if (!map_pendingSellToken.has(token_address)) {
          continue;
        }
        let token_amount = BigInt(obj_walletTokenAccount.accountInfo.amount.toString());
        // if (token_amount == 0n) {
        //   //删除此token信息 
        //   map_pendingSellToken.delete(token_address);
        //   continue;
        // }
        let obj_total_dalaoInfo = map_pendingSellToken.get(token_address).obj_total_dalaoInfo;
        let arr_dalao = Object.keys(obj_total_dalaoInfo);
        for (let dalao_address of arr_dalao) {
          let dalaoInfo = obj_total_dalaoInfo[dalao_address];
          dalaoInfo["bigint_myMainTokenAmount"] = BigInt(dalaoInfo["bigint_myMainTokenAmount"]);
          dalaoInfo["bigint_myTokenAmount"] = BigInt(dalaoInfo["bigint_myTokenAmount"]);
          dalaoInfo["bigint_dalaoTokenAmount"] = BigInt(dalaoInfo["bigint_dalaoTokenAmount"]);
          dalaoInfo["bigint_dalaoToken_PreAmount"] = BigInt(dalaoInfo["bigint_dalaoToken_PreAmount"]);
          dalaoInfo["bigint_dalaoToken_NowAmount"] = BigInt(dalaoInfo["bigint_dalaoToken_NowAmount"]);
          if (dalaoInfo["bigint_myTokenAmount"] == 0n) {
            delete obj_total_dalaoInfo[dalao_address];
          }
        }
      }

    }
    console.log("初始化待卖出代币信息成功");

  }
  catch (error) {
    console.log('初始化待卖出代币信息失败 error=', error.message);
    throw error;
  }

};

//保存待卖出代币信息到本地文本。
function savePendingSellTokens() {
  try {
    const plainObject = Map2PlainObject(map_pendingSellToken);
    fs.writeFileSync('pendingSellToken.json', JSON.stringify(plainObject));
    console.log('savePendingSellTokens success');

  } catch (error) {
    console.log('savePendingSellTokens error error=', error.message);
  }
};

function save_obj_dalao_existtxhash_2_set() {
  try {
    let new_obj_dalao_existtxhash_2_set = Map2PlainObject(obj_dalao_existtxhash_2_set);
    fs.writeJSONSync('dalao_existtxhash_2_set.json', new_obj_dalao_existtxhash_2_set, { spaces: 4 });
    console.log('save_obj_dalao_existtxhash_2_set success');
  } catch (error) {
    console.log('save_obj_dalao_existtxhash_2_set error=', error.message);
  }

}


//统计卖出失败（或者卖出金额有问题）次数, 当4小时内同一个Dalao触发风控统计超过3次,则启动风控,该Dalao不再跟单休息10小时。
async function sellFailStatistics({
  tokenAddress,
  pendingSellToken = undefined,

} = {}) {
  //保存貔貅发送者钱包
  //检查风控次数
  // 如果sleep_immediately 为true pendingSellToken应该hiundefined
  // dalaoAddress 可能为undefined 出现为undeined 一般意味着拉黑全部

  if (!pendingSellToken) {
    return;
  }
  let arr_dalaoAddress = pendingSellToken.arr_dalaoAddress;

  for (let dalaoAddress of arr_dalaoAddress) {
    let sellFailedInfo = obj_sellFailedInfo[dalaoAddress];
    if (sellFailedInfo != undefined) {
      sellFailedInfo.remainsellFailCount = sellFailedInfo.remainsellFailCount - 1;
      console.log(`PRINT dalaoAddress=${dalaoAddress} tokenAddress=${tokenAddress} remainsellFailCount ${sellFailedInfo.remainsellFailCount}`);
      if (sellFailedInfo.remainsellFailCount < 0) {
        //判断失败3次总耗时 如果大于4小时,就清零
        const etimeMinDiff = getTimeMinDiff(sellFailedInfo.sellFailStartTime, Date.now());
        if (etimeMinDiff >= 240) {
          //移除
          delete obj_sellFailedInfo[dalaoAddress];
          console.log(`PRINT dalaoAddress=${dalaoAddress} Remove_RiskControl,has_more_than_4_hours_lasttime`);
        } else {
          sellFailedInfo.stopTransactionTime = Date.now();
          console.log(`PRINT dalaoAddress=${dalaoAddress} Excute_RiskControl,Sleeping_10_hours`);
        }
      } else {
        //判断距离上次失败总耗时 如果大于4小时,就重新统计
        const etimeMinDiff = getTimeMinDiff(sellFailedInfo.sellFailStartTime, Date.now());
        if (etimeMinDiff >= 240) {
          //修改

          sellFailedInfo.sellFailStartTime = Date.now();
          console.log(`PRINT dalaoAddress=${dalaoAddress} has_more_than_4_hours_lasttime,RiskControlCount_init`);
        }
      }
    } else {
      obj_sellFailedInfo.set(dalaoAddress, { "remainsellFailCount": sellFailCountLimit - 1, "sellFailStartTime": Date.now(), "stopTransactionTime": 0 });
      console.log(`PRINT dalaoAddress=${dalaoAddress} tokenAddress=${tokenAddress} Trigger_RiskControl 1 time`);
    }
  }

};

let arr_walletTokenAccount = [];
let obj_total_ammpool = {}; // ammid ->poolkeys {}
// let obj_total_lp_info = {}; // lp_address ->info {decimals,xxx}
// let obj_total_token_info = {}; //token_address ->info  {decimals }




// let wallet = Keypair.fromSecretKey(Buffer.from(bs58.decode('41Svd4pDN1t3qhG9HH83LNsuP3ghPPDtUGKmsNoKTk6VoJXqqC9GhS7NGcwosYtm7NnDidhTWDkzKC8Gp9B7u4Av')));
// let swap_connection = new web3.Connection("https://mainnet.helius-rpc.com/?api-key=4c4f2b5f-7db5-489c-a74c-a334d8cedd76");

// arr_walletTokenAccount type is [
//   {
//     pubkey: PublicKey [PublicKey(GXGpJMgCCmJp11uPDzWBfNDu2tKpZLRjZ8vRkW6Bsf8M)] {
//       _bn: <BN: e6a09c5e639f40343b256cb45847f9c14dac8740f573a1cc6d5ad9d90224ce52>
//     },
//     programId: PublicKey [PublicKey(TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA)] {
//       _bn: <BN: 6ddf6e1d765a193d9cbe146ceeb79ac1cb485ed5f5b37913a8cf5857eff00a9>
//     },
//     accountInfo: {
//       mint: [PublicKey [PublicKey(EPjFWdd5AufqSSqeM2qN1xzybapC8G4wEGGkZwyTDt1v)]],
//       owner: [PublicKey [PublicKey(EuCYZeczx4L2y8HozZRgNsp17UtmeuN1gzBDn2ubW71k)]],
//       amount: <BN: 22>,
//       delegateOption: 0,
//       delegate: [PublicKey [PublicKey(11111111111111111111111111111111)]],
//       state: 1,
//       isNativeOption: 0,
//       isNative: <BN: 0>,
//       delegatedAmount: <BN: 0>,
//       closeAuthorityOption: 0,
//       closeAuthority: [PublicKey [PublicKey(11111111111111111111111111111111)]]
//     }
//   }
// ]


async function getWalletTokenAccount(wallet_pubkey) {

  let walletTokenAccount;

  walletTokenAccount = await swap_connection.getTokenAccountsByOwner(wallet_pubkey, {
    programId: raydium_sdk.TOKEN_PROGRAM_ID,
  });

  return walletTokenAccount.value.map((i) => ({
    pubkey: i.pubkey,
    programId: i.account.owner,
    accountInfo: raydium_sdk.SPL_ACCOUNT_LAYOUT.decode(i.account.data),
  }));

}

async function getoneWalletTokenAccount(wallet_pubkey, str_check_tokenaddress) {

  let walletTokenAccount;
  walletTokenAccount = await swap_connection.getTokenAccountsByOwner(wallet_pubkey, {
    programId: raydium_sdk.TOKEN_PROGRAM_ID,
    mint: new web3.PublicKey(str_check_tokenaddress)
  });

  return walletTokenAccount.value.map((i) => ({
    pubkey: i.pubkey,
    programId: i.account.owner,
    accountInfo: raydium_sdk.SPL_ACCOUNT_LAYOUT.decode(i.account.data),
  }));

}


async function updateWalletTokenAccount() {
  let temp_arr_walletTokenAccount;
  let retry_times = 10;
  while (retry_times > 0) {
    retry_times--;

    try {
      temp_arr_walletTokenAccount = await getWalletTokenAccount(wallet.publicKey);
      if (temp_arr_walletTokenAccount.length == 0) {
        throw new Error("length error");
      }
    } catch (e) {
      console.log("updateWalletTokenAccount error", e);
      await sleep(400);
      continue;
      // return;
    }

    arr_walletTokenAccount = temp_arr_walletTokenAccount;
    if (arr_walletTokenAccount.length != 0) {
      return arr_walletTokenAccount
    }
    await sleep(400);
  }


}
let WSOL_Token_Address = "So11111111111111111111111111111111111111112";
let Token_Transfer_programId = "TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA";
let Raydium_Authority_V4 = "5Q544fKrFoe6tsEbD7S8EmxGTJYAKtTVhAW5Q5pge4j1";

function set_token_balance(dalao_address, dict_temp_preTokenBalance, dict_temp_postTokenBalance, dalao_spl_dict, router_sol_dict, router_spl_dict) {
  if (dict_temp_preTokenBalance.programId != Token_Transfer_programId) {
    return;
  }
  if (![dalao_address, Raydium_Authority_V4].includes(dict_temp_preTokenBalance.owner)) {
    return;
  }
  // 前后tokenamount的数目没有变化 return
  if (dict_temp_preTokenBalance.uiTokenAmount.amount == dict_temp_postTokenBalance.uiTokenAmount.amount) {
    return;
  }


  if ([dalao_address].includes(dict_temp_preTokenBalance.owner)) {
    if ([WSOL_Token_Address].includes(dict_temp_preTokenBalance.mint)) {
      return;
    } else {
      dalao_spl_dict.mint.push(dict_temp_preTokenBalance.mint);
      dalao_spl_dict.balance_changes.push(-BigInt(dict_temp_preTokenBalance.uiTokenAmount.amount) + BigInt(dict_temp_postTokenBalance.uiTokenAmount.amount));
      dalao_spl_dict.prepost_balances.push([BigInt(dict_temp_preTokenBalance.uiTokenAmount.amount), BigInt(dict_temp_postTokenBalance.uiTokenAmount.amount)]);

    }
  } else if ([Raydium_Authority_V4].includes(dict_temp_preTokenBalance.owner)) {
    if ([WSOL_Token_Address].includes(dict_temp_preTokenBalance.mint)) {
      router_sol_dict.balance_changes.push(-BigInt(dict_temp_preTokenBalance.uiTokenAmount.amount) + BigInt(dict_temp_postTokenBalance.uiTokenAmount.amount));
      router_sol_dict.prepost_balances.push([BigInt(dict_temp_preTokenBalance.uiTokenAmount.amount), BigInt(dict_temp_postTokenBalance.uiTokenAmount.amount)]);
    } else {
      router_spl_dict.mint.push(dict_temp_preTokenBalance.mint);
      router_spl_dict.balance_changes.push(-BigInt(dict_temp_preTokenBalance.uiTokenAmount.amount) + BigInt(dict_temp_postTokenBalance.uiTokenAmount.amount));
      router_spl_dict.prepost_balances.push([BigInt(dict_temp_preTokenBalance.uiTokenAmount.amount), BigInt(dict_temp_postTokenBalance.uiTokenAmount.amount)]);
    }
  }

  return;
}

async function readyBuyToken({
  dalao_address,
  sign,
  str_swapintoken,
  str_swapouttoken,
  str_ammid,
  number_decimals_swapintoken,
  number_decimals_swapouttoken,
  bigint_actual_swapinamount,
  bigint_expect_swapminoutamount,
  arr_walletTokenAccount,
  wallet,
  obj_someinfo

} = {}) {
  console.log(`enter readyBuyToken dalao_address=${dalao_address} sign=${sign} str_swapouttoken=${str_swapouttoken} swapin=${bigint_actual_swapinamount} swapminout=${bigint_expect_swapminoutamount}`);

  let str_maintoken_address = str_swapintoken;
  let str_swaptoken_address = str_swapouttoken;
  let number_maintoken_decimals = number_decimals_swapintoken;
  let number_swaptoken_decimals = number_decimals_swapouttoken;


  if (dalaobuytokenscounts_obj[dalao_address][str_swaptoken_address]) {
    // dalaobuytokenscounts_obj 存在这个token信息，说明之前买过后来remove这个token了
    if (dalaobuytokenscounts_obj[dalao_address][str_swaptoken_address]['buyCounts'] >= 1) {
      console.log(`PRINT dalaoAddress=${dalao_address} tokenAddress=${str_swaptoken_address} txHash=${sign} NotBuyToken exceed_buy_counts_limits`);
      return;
    } else {
      dalaobuytokenscounts_obj[dalao_address][str_swaptoken_address]['buyCounts']++;
    }
  } else {
    dalaobuytokenscounts_obj[dalao_address][str_swaptoken_address] = { 'buyCounts': 1 };
  }

  // 三种情况,第一种完全没有这个token map_pendingSellToken 中没有 pendingSellToken
  // 第二种 有这个token 有pendingSellToken tokenInfoMap没有这个dalao
  // 第三种 有这个token  有 pendingSellToken tokenInfoMap有这个dalao
  // 对于dalao信息的设置 全部在buy成功之后再说
  let map_pendingSellToken_value = map_pendingSellToken.get(str_swaptoken_address);
  let obj_dalaoInfo;

  if (map_pendingSellToken_value == undefined) {
    //第一种 map_pendingSellToken 没有此token 设置
    map_pendingSellToken.set(str_swaptoken_address, {
      "str_maintoken": str_maintoken_address,
      "str_swaptoken": str_swaptoken_address,
      "ammid": str_ammid,
      "number_maintoken_decimals": number_maintoken_decimals,
      "number_swaptoken_decimals": number_swaptoken_decimals,
      "number_totallastBuydatenow": 0,
      "arr_dalaoAddress": [dalao_address],
      "arr_txHash": [],
      "obj_total_dalaoInfo": {}

    });


    map_pendingSellToken_value = map_pendingSellToken.get(str_swaptoken_address);
    map_pendingSellToken_value.obj_total_dalaoInfo[dalao_address] = {
      "str_dalao_address": dalao_address,
      "str_maintoken": str_maintoken_address,
      "str_swaptoken": str_swaptoken_address,
      "ammid": str_ammid,
      "isSelling": false,
      "bigint_myMainTokenAmount": 0n,
      "bigint_myTokenAmount": 0n,
      "str_maxbuyprice": "",
      "bigint_dalaoTokenAmount": 0n,
      "bigint_dalaoToken_PreAmount": 0n,
      "bigint_dalaoToken_NowAmount": 0n
    };
    obj_dalaoInfo = map_pendingSellToken_value.obj_total_dalaoInfo[dalao_address];
  } else {
    //第二种与第三种
    //第三种是 obj_dalaoInfo!=undefined 在后面与 第一种第二种统一操作
    obj_dalaoInfo = map_pendingSellToken_value.obj_total_dalaoInfo[dalao_address];
    if (obj_dalaoInfo == undefined) {
      // 第二种 有这个token 有pendingSellToken tokenInfoMap没有这个dalao
      //准备购买
      map_pendingSellToken_value.obj_total_dalaoInfo[dalao_address] = {
        "str_dalao_address": dalao_address,
        "str_maintoken": str_maintoken_address,
        "str_swaptoken": str_swaptoken_address,
        "ammid": str_ammid,
        "isSelling": false,
        "bigint_myMainTokenAmount": 0n,
        "bigint_myTokenAmount": 0n,
        "str_maxbuyprice": "",
        "bigint_dalaoTokenAmount": 0n,
        "bigint_dalaoToken_PreAmount": 0n,
        "bigint_dalaoToken_NowAmount": 0n
      }

      obj_dalaoInfo = map_pendingSellToken_value.obj_total_dalaoInfo[dalao_address];
    }

  }
  if (!map_pendingSellToken_value) {
    console.log("map_pendingSellToken_value undefined");
    return;
  }
  map_pendingSellToken_value.number_totallastBuydatenow = Date.now();
  map_pendingSellToken_value.arr_txHash.push(sign);
  if (!map_pendingSellToken_value.arr_dalaoAddress.includes(dalao_address)) {
    map_pendingSellToken_value.arr_dalaoAddress.push(dalao_address)
  }
  if (map_pendingSellToken_value.arr_dalaoAddress.length <= 1) {
    //只有一个dalao购买此token 不会做买入操作
    console.log(`PRINT dalaoAddress=${dalao_address} tokenAddress=${str_swaptoken_address} txHash=${sign} NotBuyToken  Token第一次购买`);
    // 第一个dalao一直在买 次数置为1 为了以后其他dalao买了之后可以在买一次
    dalaobuytokenscounts_obj[dalao_address][str_swaptoken_address]['buyCounts'] = 1;
    return;
  }
  obj_dalaoInfo.bigint_dalaoToken_NowAmount = obj_someinfo.bigint_dalaoToken_NowAmount;
  obj_dalaoInfo.bigint_dalaoToken_PreAmount = obj_someinfo.bigint_dalaoToken_NowAmount;


  let str_ata = map_pendingSellToken_value.str_ata;
  let arr_one_walletTokenAccount = [];
  if (str_ata != undefined) {
    arr_one_walletTokenAccount = [{
      "pubkey": new web3.PublicKey(str_ata),
      "programId": new web3.PublicKey("TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA"),
      "accountInfo": {
        "mint": new web3.PublicKey(str_swapintoken),
        "owner": new PublicKey(mywalletaddress),
        "amount": new BN("11111111111", 16),
        "delegateOption": 0,
        "delegate": new web3.PublicKey("11111111111111111111111111111111"),
        "state": 1,
        "isNativeOption": 0,
        "isNative": new BN("00", 16),
        "delegatedAmount": new BN("00", 16),
        "closeAuthorityOption": 0,
        "closeAuthority": new web3.PublicKey("11111111111111111111111111111111")
      }
    }]

  } else {
    ;
  }

  await buyToken({
    dalao_address,
    sign,
    str_maintoken_address,
    str_swaptoken_address,
    str_ammid,
    number_maintoken_decimals,
    number_swaptoken_decimals,
    bigint_actual_swapinamount,
    bigint_expect_swapminoutamount,
    arr_walletTokenAccount,
    wallet,
    arr_one_walletTokenAccount,
    number_dalao_fee: obj_someinfo.number_dalao_fee,
    number_dalao_computeUnitsConsumed: obj_someinfo.number_dalao_computeUnitsConsumed,
  });

}


function get_dalaoArouter_changes_info(dalao_address, obj_transaction) {
  let temp_preTokenBalances_arr = [];
  let temp_postTokenBalances_arr = [];

  let slot = obj_transaction['slot'];
  temp_preTokenBalances_arr = obj_transaction["meta"]["preTokenBalances"];
  temp_postTokenBalances_arr = obj_transaction["meta"]["postTokenBalances"];
  let dalao_sol_dict = {
    "owner": dalao_address,
    "mint": [WSOL_Token_Address],
    "programId": Token_Transfer_programId,
    "balance_changes": [],
    "prepost_balances": [],

  };
  let dalao_spl_dict = {
    "owner": dalao_address,
    "mint": [],
    "programId": Token_Transfer_programId,
    "balance_changes": [],
    "prepost_balances": [],

  };
  let router_sol_dict = {
    "owner": Raydium_Authority_V4,
    "mint": [WSOL_Token_Address],
    "programId": Token_Transfer_programId,
    "balance_changes": [],
    "prepost_balances": [],

  };
  let router_spl_dict = {
    "owner": Raydium_Authority_V4,
    "mint": [],
    "programId": Token_Transfer_programId,
    "balance_changes": [],
    "prepost_balances": [],

  };
  // pre/postTokenBalances 理论上有三个 分别是router的wsol与spl的transfer dalao的spl transfer
  let temp_preTokenBalances_len = temp_preTokenBalances_arr.length;
  let temp_postTokenBalances_len = temp_postTokenBalances_arr.length;

  let temp_preTokenBalances_idx = 0
  let temp_postTokenBalances_idx = 0
  // # 获取TokenBalances与swap有关的信息
  // # for tokenbalance_idx in range(0,temp_postTokenBalances_len):
  // # 理论上 post >=pre 因为可能存在账户 在pre没有创建 在post创建  不会在pre中显示
  while (temp_preTokenBalances_idx < temp_preTokenBalances_len && temp_postTokenBalances_idx < temp_postTokenBalances_len) {
    let dict_temp_preTokenBalance = null;
    let dict_temp_postTokenBalance = null;

    if (temp_preTokenBalances_arr[temp_preTokenBalances_idx].accountIndex < temp_postTokenBalances_arr[temp_postTokenBalances_idx].accountIndex) {
      dict_temp_preTokenBalance = temp_preTokenBalances_arr[temp_preTokenBalances_idx];
      dict_temp_postTokenBalance = deepcopy(dict_temp_preTokenBalance);

      dict_temp_postTokenBalance.uiTokenAmount.amount = "0";
      temp_preTokenBalances_idx++;
    } else if (temp_preTokenBalances_arr[temp_preTokenBalances_idx].accountIndex > temp_postTokenBalances_arr[temp_postTokenBalances_idx].accountIndex) {
      dict_temp_postTokenBalance = temp_postTokenBalances_arr[temp_postTokenBalances_idx];

      dict_temp_preTokenBalance = deepcopy(dict_temp_postTokenBalance);

      dict_temp_preTokenBalance.uiTokenAmount.amount = "0";
      temp_postTokenBalances_idx++;
    } else {
      dict_temp_preTokenBalance = temp_preTokenBalances_arr[temp_preTokenBalances_idx];
      dict_temp_postTokenBalance = temp_postTokenBalances_arr[temp_postTokenBalances_idx];
      temp_preTokenBalances_idx++;
      temp_postTokenBalances_idx++;
    }

    set_token_balance(dalao_address, dict_temp_preTokenBalance, dict_temp_postTokenBalance, dalao_spl_dict, router_sol_dict, router_spl_dict);
  }

  while (temp_preTokenBalances_idx < temp_preTokenBalances_len) {
    let dict_temp_preTokenBalance = temp_preTokenBalances_arr[temp_preTokenBalances_idx];

    let dict_temp_postTokenBalance = deepcopy(dict_temp_preTokenBalance);
    dict_temp_postTokenBalance.uiTokenAmount.amount = "0";
    set_token_balance(dalao_address, dict_temp_preTokenBalance, dict_temp_postTokenBalance, dalao_spl_dict, router_sol_dict, router_spl_dict);
    temp_preTokenBalances_idx += 1;
  }

  while (temp_postTokenBalances_idx < temp_postTokenBalances_len) {
    let dict_temp_postTokenBalance = temp_postTokenBalances_arr[temp_postTokenBalances_idx];

    let dict_temp_preTokenBalance = deepcopy(dict_temp_postTokenBalance);
    dict_temp_preTokenBalance.uiTokenAmount.amount = "0";
    set_token_balance(dalao_address, dict_temp_preTokenBalance, dict_temp_postTokenBalance, dalao_spl_dict, router_sol_dict, router_spl_dict);
    temp_postTokenBalances_idx += 1;
  }

  return [dalao_spl_dict, router_sol_dict, router_spl_dict];


}
async function get_dalao_transaction_info(dalao_address, sign, obj_transaction) {

  // dalao transaction 获取到 dalao 与raydium pool 的token transfer 信息 并与 swap instruction 进行比较 
  // 1 buy raydium in wsol out token dalao in token
  // 2 sell
  // 3 sell 没有swap 或者swap 与token 无关 dalao out token 在pendingsellToken信息中
  // 判断sell 比较简单 只要 dalao 出现 dalao tokenamount 减少  就sell
  //判断buy 满足 dalao in token， raydium pool in wsol ，out token token 与 sol 在swap 的instruction 可以找到
  console.log(`enter get_dalao_transaction_info dalao_address=${dalao_address} sign=${sign}`)
  let dalao_spl_dict, router_sol_dict, router_spl_dict;
  let obj_dalao_transaction_info = {
    "str_swaptype": "noswap",
    "str_dalao_intoken": "",
    "str_dalao_outtoken": "",
    "str_ammid": "",
    "bigint_dalaoinamount": 0n,
    "bigint_dalaooutamount": 0n,
    "number_decimals_dalao_intoken": 0,
    "number_decimals_dalao_outtoken": 0,
    "bigint_dalaoToken_PreAmount": 0n,
    "bigint_dalaoToken_NowAmount": 0n,
    "number_dalao_fee": 0,
    "number_dalao_computeUnitsConsumed": 0,
  };
  let number_dalao_fee = obj_transaction.meta.fee;
  let number_dalao_computeUnitsConsumed = obj_transaction.meta.computeUnitsConsumed;
  obj_dalao_transaction_info.number_dalao_fee = number_dalao_fee;
  obj_dalao_transaction_info.number_dalao_computeUnitsConsumed = number_dalao_computeUnitsConsumed;


  [dalao_spl_dict, router_sol_dict, router_spl_dict] = get_dalaoArouter_changes_info(dalao_address, obj_transaction);

  if (
    dalao_spl_dict["balance_changes"].length == 0 ||
    router_sol_dict["balance_changes"].length == 0 ||
    router_spl_dict["balance_changes"].length == 0
  ) {
    // 如果 dalao 与router 没有 TokenBalances的信息 也就是没有token transfer的信息  说明此tx不是所需的swap
    console.log(`get_dalao_transaction_info  no balance_changes`);
    return;
  }

  // 判断 是swap type 先判断dalao outtoken 情况
  // 只要 dalao 有outtoken 就算sell 不用考虑太复杂 这和你赚第一通金无关

  let dalao_spl_in_counts = 0;
  let dalao_spl_out_counts = 0;
  for (let dalao_mint_idx = 0; dalao_mint_idx < dalao_spl_dict.mint.length; dalao_mint_idx++) {
    //此轮循环值判断 balance_changes<0 即疑似卖出的情况
    let token_address = dalao_spl_dict.mint[dalao_mint_idx];
    let bigint_dalao_spl_balance_changes = dalao_spl_dict.balance_changes[dalao_mint_idx];
    let bigint_dalao_spl_prebalance = dalao_spl_dict.prepost_balances[dalao_mint_idx][0];
    let bigint_dalao_spl_postbalance = dalao_spl_dict.prepost_balances[dalao_mint_idx][1];

    if (bigint_dalao_spl_balance_changes >= 0n) {
      dalao_spl_in_counts++;
      continue;
    }
    dalao_spl_out_counts++;

    let map_pendingSellToken_value = map_pendingSellToken.get(token_address);
    if (map_pendingSellToken_value == undefined) {
      //map_pendingSellToken 没有此token 跳过
      continue;
    }
    let obj_dalaoInfo = map_pendingSellToken_value.obj_total_dalaoInfo[dalao_address];
    if (obj_dalaoInfo == undefined) {
      console.log(`get_dalao_transaction_info sign=${sign} obj_dalaoInfo is undefined`);
      return;
    }


    obj_dalao_transaction_info.str_swaptype = "sell";
    obj_dalao_transaction_info.str_dalao_intoken = map_pendingSellToken_value.str_maintoken;
    obj_dalao_transaction_info.str_dalao_outtoken = map_pendingSellToken_value.str_swaptoken;
    obj_dalao_transaction_info.str_ammid = map_pendingSellToken_value.ammid;
    obj_dalao_transaction_info.bigint_dalaoinamount = 0n;
    obj_dalao_transaction_info.bigint_dalaooutamount = -bigint_dalao_spl_balance_changes;
    obj_dalao_transaction_info.number_decimals_dalao_intoken = map_pendingSellToken_value.number_maintoken_decimals;
    obj_dalao_transaction_info.number_decimals_dalao_outtoken = map_pendingSellToken_value.number_swaptoken_decimals;
    // obj_dalao_transaction_info.number_sellpercent = Number((-bigint_dalao_spl_balance_changes) * 100n / bigint_dalao_spl_prebalance) / 100;
    obj_dalao_transaction_info.bigint_dalaoToken_PreAmount = bigint_dalao_spl_prebalance;
    obj_dalao_transaction_info.bigint_dalaoToken_NowAmount = bigint_dalao_spl_postbalance;

    return obj_dalao_transaction_info;

  }
  if (dalao_spl_in_counts == 0) {
    console.log(`get_dalao_transaction_info sign=${sign} may selltoken i dont has`);
    return;
  }


  let arr_ammid = Object.keys(obj_transaction.obj_swap_instructions);

  for (let ammid_idx = 0; ammid_idx < arr_ammid.length; ammid_idx++) {
    //此轮循环遍历 arr_ammid 寻找 wsol--token的ammid 并且dalao的token是 balance_changes>0 即疑似买入的情况
    let str_ammid = arr_ammid[ammid_idx];
    let amm_pool_info = obj_total_ammpool[str_ammid];
    if (!amm_pool_info) {
      // baseMint: info.baseMint.toString(),
      // quoteMint: info.quoteMint.toString(),
      // lpMint: info.lpMint.toString(),
      // baseDecimals: info.baseDecimal.toNumber(),
      // quoteDecimals: info.quoteDecimal.toNumber(),

      amm_pool_info = await formatAmmKeysById(str_ammid);
      obj_total_ammpool[str_ammid] = amm_pool_info;
    }

    let baseMint = amm_pool_info.baseMint;
    let quoteMint = amm_pool_info.quoteMint;
    let baseDecimals = amm_pool_info.baseDecimals;
    let quoteDecimals = amm_pool_info.quoteDecimals;

    if (baseMint != WSOL_Token_Address && quoteMint != WSOL_Token_Address) {
      //此swap 不是 SOL--Token的结构
      continue;
    }
    //遍历 instructions
    let swap_token_address, swap_token_decimals, main_token_address, main_token_decimals;
    if (baseMint == WSOL_Token_Address) {
      main_token_address = baseMint;
      main_token_decimals = baseDecimals;
      swap_token_address = quoteMint;
      swap_token_decimals = quoteDecimals;
    } else {
      main_token_address = quoteMint;
      main_token_decimals = quoteDecimals;
      swap_token_address = baseMint;
      swap_token_decimals = baseDecimals;
    }


    let dalao_spl_idx = dalao_spl_dict.mint.indexOf(swap_token_address);
    if (dalao_spl_idx == -1) {
      continue;
    }
    // 选好了 就是buy 此token 判断之前是否购买过，购买次数是否超了

    let bigint_dalao_spl_prebalance = dalao_spl_dict.prepost_balances[dalao_spl_idx][0];
    let bigint_dalao_spl_postbalance = dalao_spl_dict.prepost_balances[dalao_spl_idx][1];


    obj_dalao_transaction_info.str_swaptype = "buy";
    obj_dalao_transaction_info.str_dalao_intoken = swap_token_address;
    obj_dalao_transaction_info.str_dalao_outtoken = main_token_address;
    obj_dalao_transaction_info.str_ammid = str_ammid;
    obj_dalao_transaction_info.bigint_dalaoinamount = dalao_spl_dict.balance_changes[dalao_spl_idx];
    obj_dalao_transaction_info.bigint_dalaooutamount = router_sol_dict.balance_changes[0];
    obj_dalao_transaction_info.number_decimals_dalao_intoken = swap_token_decimals;
    obj_dalao_transaction_info.number_decimals_dalao_outtoken = main_token_decimals;
    obj_dalao_transaction_info.bigint_dalaoToken_PreAmount = bigint_dalao_spl_prebalance;
    obj_dalao_transaction_info.bigint_dalaoToken_NowAmount = bigint_dalao_spl_postbalance;
    return obj_dalao_transaction_info;
  }
  return obj_dalao_transaction_info;

}






function init_total_ammpool() {
  try {
    if (!fs.existsSync('total_ammpool.json')) {
      console.log('init_total_ammpool success');
      return
    }

    obj_total_ammpool = fs.readJSONSync('total_ammpool.json', { encoding: 'utf8', flag: 'r' });
    console.log('init_total_ammpool success');
  } catch (error) {
    console.log('init_total_ammpool error=', error.message);
  }


}



async function multimes_getTransaction(sign, retry_times = 10) {
  // let retry_times = 10;
  let obj_transaction;
  while (retry_times > 0) {
    obj_transaction = await swap_connection.getTransaction(sign, { commitment: "confirmed", maxSupportedTransactionVersion: 0 });
    if (obj_transaction) {
      break;
    }
    else {
      retry_times--;
      await sleep(1200);
      continue;
    }
  }
  if (retry_times <= 0) {
    console.log(`multimes_getTransaction_() failed sign=${sign}`);
    throw new Error("not get transaction");
  }
  return obj_transaction
}


async function check_transaction(str_dalao_address, sign) {
  console.log(`check_transaction str_dalao_address=${str_dalao_address} sign=${sign}`);

  // let swaptype, str_dalao_intoken, str_dalao_outtoken, str_token_pool, bigint_dalaoinamount, bigint_dalaooutamount;
  // [swaptype, str_dalao_intoken, str_dalao_outtoken, str_token_pool, bigint_dalaoinamount, bigint_dalaooutamount]
  let obj_transaction;
  try {
    obj_transaction = await multimes_getTransaction(sign);
  } catch (e) {
    console.log(`check_transaction_() str_dalao_address=${str_dalao_address} sign=${sign} ${e.message}`)
    return;
  }

  let meta_err = obj_transaction.meta.err;
  if (meta_err != null) {
    console.log(`tx is unsuccessful sign=${sign}`);
    return;
  }
  obj_transaction = parsedtransactionAndfindammid(obj_transaction, str_dalao_address);
  if (obj_transaction == undefined) {
    console.log(`parsedtransactionAndfindammid is undefined sign=${sign}`);
    return;
  }
  fs.writeJSONSync(`./myparsedtransactionAndfindammid/${sign}.json`, obj_transaction, { spaces: 4 });

  let obj_dalao_transaction_info = await get_dalao_transaction_info(str_dalao_address, sign, obj_transaction);

  if (obj_dalao_transaction_info == undefined || obj_dalao_transaction_info.str_swaptype == "noswap") {
    console.log(`check_transaction str_swaptype=noswap sign=${sign} str_dalao_address=${str_dalao_address}`);
    return;
  }

  let str_swaptype = obj_dalao_transaction_info.str_swaptype;
  let str_swapintoken = obj_dalao_transaction_info.str_dalao_outtoken;
  let str_swapouttoken = obj_dalao_transaction_info.str_dalao_intoken;
  let str_ammid = obj_dalao_transaction_info.str_ammid;
  let number_decimals_swapintoken = obj_dalao_transaction_info.number_decimals_dalao_outtoken;
  let number_decimals_swapouttoken = obj_dalao_transaction_info.number_decimals_dalao_intoken;

  let bigint_actual_swapinamount = 0n;
  let bigint_expect_swapoutamount = 0n;
  let bigint_expect_swapminoutamount = 0n;

  let bigint_dalaoToken_PreAmount = obj_dalao_transaction_info.bigint_dalaoToken_PreAmount;
  let bigint_dalaoToken_NowAmount = obj_dalao_transaction_info.bigint_dalaoToken_NowAmount;

  let number_dalao_fee = obj_dalao_transaction_info.number_dalao_fee;
  let number_dalao_computeUnitsConsumed = obj_dalao_transaction_info.number_dalao_computeUnitsConsumed;

  if (str_dalao_address == mywalletaddress) {
    // 如果是检测的自己的txhash

    str_dalao_address = obj_mine_pendingtxhash_2_dalaoinfo[sign]["str_dalao_address"];
    let str_swaptoken_address = obj_mine_pendingtxhash_2_dalaoinfo[sign]["str_swaptoken_address"];

    let map_pendingSellToken_value = map_pendingSellToken.get(str_swaptoken_address);
    if (map_pendingSellToken_value == undefined) {
      console.log(`NotSell dalao_address=${str_dalao_address} str_swaptoken_address=${str_swaptoken_address} map_pendingSellToken_value is undefined`);
      return;
    }
    let obj_dalaoInfo = map_pendingSellToken_value.obj_total_dalaoInfo[str_dalao_address];
    if (obj_dalaoInfo == undefined) {
      console.log(`NotSell dalao_address=${str_dalao_address} str_swaptoken_address=${str_swaptoken_address} obj_dalaoInfo is undefined`);
      return;
    }

    obj_dalaoInfo.bigint_myTokenAmount = obj_dalaoInfo.bigint_myTokenAmount + bigint_dalaoToken_NowAmount - bigint_dalaoToken_PreAmount;

    delete obj_mine_pendingtxhash_2_dalaoinfo[sign];
    return;
  }

  if (str_swaptype == "buy") {
    //buytoken swapin wsol swapout token
    bigint_actual_swapinamount = obj_dalao_transaction_info.bigint_dalaooutamount < buySolAmount0_2 ? obj_dalao_transaction_info.bigint_dalaooutamount : buySolAmount0_2;
    bigint_expect_swapoutamount = obj_dalao_transaction_info.bigint_dalaoinamount * bigint_actual_swapinamount / obj_dalao_transaction_info.bigint_dalaooutamount;
    bigint_expect_swapminoutamount = bigint_expect_swapoutamount * 7n / 10n; //浮点30%
  } else {
    //sell token 计算卖出比例
    ;
  }

  // await updateWalletTokenAccount();

  if (str_swaptype == "buy") {
    await readyBuyToken({
      dalao_address: str_dalao_address,
      sign,
      str_swapintoken,
      str_swapouttoken,
      str_ammid,
      number_decimals_swapintoken,
      number_decimals_swapouttoken,
      bigint_actual_swapinamount,
      bigint_expect_swapminoutamount,
      arr_walletTokenAccount,
      wallet,
      obj_someinfo: {
        bigint_dalaoToken_PreAmount: bigint_dalaoToken_PreAmount,
        bigint_dalaoToken_NowAmount: bigint_dalaoToken_NowAmount,
        number_dalao_fee: number_dalao_fee,
        number_dalao_computeUnitsConsumed: number_dalao_computeUnitsConsumed,

      }


    });

  } else {
    await sellToken(
      {
        dalao_address: str_dalao_address,
        sign,
        str_swapintoken,
        str_swapouttoken,
        str_ammid,
        number_decimals_swapintoken,
        number_decimals_swapouttoken,

        arr_walletTokenAccount,
        wallet,
        obj_someinfo: {
          bigint_dalaoToken_PreAmount: bigint_dalaoToken_PreAmount,
          bigint_dalaoToken_NowAmount: bigint_dalaoToken_NowAmount,
          number_dalao_fee: number_dalao_fee,
          number_dalao_computeUnitsConsumed: number_dalao_computeUnitsConsumed,

        }

      }
    )

  }




}





let number_saveInfoByTimed = Date.now()
async function saveInfoByTimed() {
  let DiffMin = (Date.now() - number_saveInfoByTimed) / 1000 / 60;
  if (DiffMin >= 20) {
    number_saveInfoByTimed = Date.now();
    savePendingSellTokens();
    saveWalletTokenAccount();
    saveTotalAmmpool();
    save_obj_dalao_existtxhash_2_set();
  }


}



let sendtransactiion_connection = new web3.Connection("https://mainnet.helius-rpc.com/?api-key=4c4f2b5f-7db5-489c-a74c-a334d8cedd76");

let swap_connection = new web3.Connection("https://solana-mainnet.g.alchemy.com/v2/WLI0ohbUlvbsJVmoIvB1wTSwUA8qP5qS");
let alchemy_connection_0 = new web3.Connection("https://solana-mainnet.g.alchemy.com/v2/ck1dtOx8tHkjAH2PX2FwTGN2T2gDaGtV");
let alchemy_connection_1 = new web3.Connection("https://solana-mainnet.g.alchemy.com/v2/pxF-cEkEE1JxzxgotGyww5ra5w1IvAkJ");

let alchemy_url_0 = ("https://solana-mainnet.g.alchemy.com/v2/ck1dtOx8tHkjAH2PX2FwTGN2T2gDaGtV");
let alchemy_url_1 = ("https://solana-mainnet.g.alchemy.com/v2/pxF-cEkEE1JxzxgotGyww5ra5w1IvAkJ");

let arr_listen_connection = [alchemy_connection_0, alchemy_connection_1];

let arr_listen_url = [alchemy_url_0, alchemy_url_1];

async function check_dalao_getsignatures(str_dalao_address, listen_url, connection, limit = 5) {
  if (obj_dalao_isbusy[str_dalao_address] && limit == 5) {
    console.log(`${str_dalao_address} is busying`)
    return;
  }
  obj_dalao_isbusy[str_dalao_address] = true;
  let dalao_existtxhash_set = obj_dalao_existtxhash_2_set[str_dalao_address];
  // let requestSignatures = await connection.getSignaturesForAddress(web3pub_dalaoaddd, {
  //   limit: limit,
  // }, 'confirmed');
  let listen_body_data = `{"id":"${guid()}","jsonrpc":"2.0","method":"getSignaturesForAddress","params":["${str_dalao_address}",{"limit":5, "commitment": "confirmed"}]}`;
  let requestSignatures = await axios.post(listen_url, listen_body_data, listen_axios_config);

  if (requestSignatures.status == 200 && requestSignatures.error) {
    throw new Error(requestSignatures.error.message);
  } else if (requestSignatures.status != 200) {
    console.log(`str_dalao_address=${str_dalao_address} listen_url=${listen_url} status!=200`);
    throw new Error("status!=200");
  }
  requestSignatures = requestSignatures.data.result;
  let FetchedSignatureArray = [];

  for (let requestSignature of requestSignatures) {
    if (requestSignature.err != null) {
      continue;
    }
    FetchedSignatureArray.push(requestSignature.signature);

  }

  if (FetchedSignatureArray.length == 0) {
    //获取的txhash 全是err
    if (limit != 5) {
      //已经递归过了  还没有成功的txhash 直接pass
      console.log(`str_dalao_address=${str_dalao_address} limit=${limit} FetchedSignatureArray=[] check_getsignatures failed`);
      obj_dalao_isbusy[str_dalao_address] = false;
      return;
    }
    await check_dalao_getsignatures(str_dalao_address, listen_url, connection, 20);
    obj_dalao_isbusy[str_dalao_address] = false;
    return;
  }

  if (dalao_existtxhash_set.has(FetchedSignatureArray[0])) {
    //没有新的txhash
    obj_dalao_isbusy[str_dalao_address] = false;
    return;
  }


  if (!dalao_existtxhash_set.has(FetchedSignatureArray[FetchedSignatureArray.length - 1])) {
    //没有获取dalao 全部的最新txhash
    if (limit != 5) {
      //已经递归过了  还没有全部获取 直接pass
      for (let txhash of FetchedSignatureArray) {
        if (dalao_existtxhash_set.has(txhash)) {
          continue;
        }
        dalao_existtxhash_set.add(txhash);
        console.log(`str_dalao_address=${str_dalao_address} add txhash in limit!=5 ${txhash}`);
      }
      console.log(`str_dalao_address=${str_dalao_address} limit=${limit} check_getsignatures failed`);
      obj_dalao_isbusy[str_dalao_address] = false;
      return;
    }
    await check_dalao_getsignatures(str_dalao_address, listen_url, connection, 20);
    obj_dalao_isbusy[str_dalao_address] = false;
    return;
  }
  FetchedSignatureArray = FetchedSignatureArray.reverse();
  let new_FetchedSignatureArray = [];

  for (let txhash of FetchedSignatureArray) {
    // 新txhash放入 dalao_existtxhash_set 并且 放入new_FetchedSignatureArray进行检查
    if (dalao_existtxhash_set.has(txhash)) {
      continue;
    }
    dalao_existtxhash_set.add(txhash);
    new_FetchedSignatureArray.push(txhash);
    console.log(`str_dalao_address=${str_dalao_address} add txhash limit=5 ${txhash}`);
  }


  for (let txhash of new_FetchedSignatureArray) {
    try {
      await check_transaction(str_dalao_address, txhash);
    } catch (e) {
      console.log(`txhash=${txhash} e=`, e);
      console.log(`txhash=${txhash} trace=`, e.stack.split('\n'));
    }

  }
  obj_dalao_isbusy[str_dalao_address] = false;
  return;
}



async function check_mine_getsignatures(str_dalao_address, listen_url, connection, limit = 5) {

  if (obj_dalao_isbusy[str_dalao_address] && limit == 5) {
    console.log(`${str_dalao_address} is busying`)
    return;
  }
  obj_dalao_isbusy[str_dalao_address] = true;
  let dalao_existtxhash_set = obj_dalao_existtxhash_2_set[str_dalao_address];
  // let requestSignatures = await connection.getSignaturesForAddress(web3pub_dalaoaddd, {
  //   limit: limit,
  // }, 'confirmed');
  let listen_body_data = `{"id":"${guid()}","jsonrpc":"2.0","method":"getSignaturesForAddress","params":["${str_dalao_address}",{"limit":5, "commitment": "confirmed"}]}`;
  let requestSignatures = await axios.post(listen_url, listen_body_data, listen_axios_config);

  if (requestSignatures.status == 200 && requestSignatures.error) {
    throw new Error(requestSignatures.error.message);
  } else if (requestSignatures.status != 200) {
    console.log(`str_dalao_address=${str_dalao_address} listen_url=${listen_url} status!=200`);
    throw new Error("status!=200");
  }
  requestSignatures = requestSignatures.data.result;
  let FetchedSignatureArray = [];


  for (let requestSignature of requestSignatures) {
    if (requestSignature.err != null) {
      if (obj_mine_pendingtxhash_2_dalaoinfo[requestSignature.signature] != undefined) {
        console.log(`mine_pendingtxhsh ${requestSignature.signature} err`);
        delete obj_mine_pendingtxhash_2_dalaoinfo[requestSignature.signature]
      }
      continue;
    }
    FetchedSignatureArray.push(requestSignature.signature);

  }
  FetchedSignatureArray = FetchedSignatureArray.reverse();
  let new_FetchedSignatureArray = [];

  for (let txhash of FetchedSignatureArray) {
    // 新txhash放入 dalao_existtxhash_set 并且 放入new_FetchedSignatureArray进行检查
    if (obj_mine_pendingtxhash_2_dalaoinfo[txhash] == undefined) {
      continue;
    }
    new_FetchedSignatureArray.push(txhash);
    console.log(`str_dalao_address=${str_dalao_address} add txhash limit=5 ${txhash}`);
  }


  for (let txhash of new_FetchedSignatureArray) {
    try {
      await check_transaction(str_dalao_address, txhash);
    } catch (e) {
      console.log(`txhash=${txhash} e=`, e);
      console.log(`txhash=${txhash} trace=`, e.stack.split('\n'));
    }

  }
  obj_dalao_isbusy[str_dalao_address] = false;
  return;



}

//待卖出代币map key:token
let map_pendingSellToken = new Map();
let now_listen_rpc_idx = 0;
let now_dalao_idx = 0;
async function listen_dalao_txhash() {

  // 1秒监听3个
  let begin_dalao_idx = now_dalao_idx;
  let end_dalao_idx = now_dalao_idx + 2;
  now_dalao_idx = (now_dalao_idx + 3) % len_arr_total_dalaoAddress;

  for (let cur_dalao_idx = begin_dalao_idx; cur_dalao_idx <= end_dalao_idx; cur_dalao_idx++) {
    let str_dalao_address = arr_total_str_dalaoAddress_forlisten[cur_dalao_idx];
    // let web3pub_dalaoaddd = arr_total_web3pub_dalaoAddress_forlisten[cur_dalao_idx];
    let listen_connection = arr_listen_connection[now_listen_rpc_idx];
    let listen_url = arr_listen_url[now_listen_rpc_idx];
    now_listen_rpc_idx = (now_listen_rpc_idx + 1) % 2;
    try {
      if (str_dalao_address == mywalletaddress) {
        await check_mine_getsignatures(str_dalao_address, listen_url, listen_connection, 5);
      } else {
        await check_dalao_getsignatures(str_dalao_address, listen_url, listen_connection, 5);
      }

    } catch (error) {

      if ((error.message).indexOf("timeout") != -1) {
        console.log(`listen_url=${listen_url} AxiosError: timeout`);
        await sleep(3000);
        obj_dalao_isbusy[str_dalao_address] = false;
        return;
      } else {
        console.log("error.message=", error.message);
        obj_dalao_isbusy[str_dalao_address] = false;
        throw error;
      }

    }

  }



}
//定时任务
async function timedTasks() {
  saveInfoByTimed();
  listen_dalao_txhash();


}
async function startWSSpink() {
  //全局捕获错误
  process.on('unhandledRejection', error => {
    if (error.message.indexOf("data out-of-bounds") == -1 && error.message.indexOf("overflow") == -1 && error.message.indexOf("toLowerCase") == -1) {
      console.log("-------------------------其他错误-------------------------", error);
    }
  });

  //请注意killall -9 node 是强制关闭,不能被监听到,需要使用 killall -15 node
  process.on('SIGTERM', async function () {
    console.log("跟单系统正在关闭......请稍等,执行相关保存任务中");

    savePendingSellTokens();
    saveWalletTokenAccount();
    saveTotalAmmpool();
    save_obj_dalao_existtxhash_2_set();

    console.log("执行完毕，正在退出");
    process.exit(0);
  });
  crontask = cron.schedule('*/1 * * * * *', () => {
    //定时任务
    timedTasks();
  });
  crontask.start();
}

async function startmenu() {
  clear();
  const starting = () => {
    console.log('\u001B[33m%s\x1b[0m', `\n  
██████╗░░██████╗░█████╗░  ░██████╗███╗░░██╗██╗██████╗░███████╗██████╗░
██╔══██╗██╔════╝██╔══██╗  ██╔════╝████╗░██║██║██╔══██╗██╔════╝██╔══██╗
██████╦╝╚█████╗░██║░░╚═╝  ╚█████╗░██╔██╗██║██║██████╔╝█████╗░░██████╔╝
██╔══██╗░╚═══██╗██║░░██╗  ░╚═══██╗██║╚████║██║██╔═══╝░██╔══╝░░██╔══██╗
██████╦╝██████╔╝╚█████╔╝  ██████╔╝██║░╚███║██║██║░░░░░███████╗██║░░██║
╚═════╝░╚═════╝░░╚════╝░  ╚═════╝░╚═╝░░╚══╝╚═╝╚═╝░░░░░╚══════╝╚═╝░░╚═╝

█▀█ ▄▀█ █▄░█ █▀▀ ▄▀█ █▄▀ █▀▀ █▀ █░█░█ ▄▀█ █▀█
█▀▀ █▀█ █░▀█ █▄▄ █▀█ █░█ ██▄ ▄█ ▀▄▀▄▀ █▀█ █▀▀
`)
  };
  let menu = '1';

  if (menu == '1') {
    clear();
    starting();


    console.log('gendan starting');
    console.time('WSS speed');
    let balance = await swap_connection.getBalance(new PublicKey(mywalletaddress));
    let mybalance = balance / (10 ** 9);
    console.log("my Balance", mybalance);

    await updateWalletTokenAccount();
    saveWalletTokenAccount();
    initPendingSellTokens();

    init_total_ammpool();
    makedirpath(`./myparsedtransactionAndfindammid/`);



    startWSSpink();
  }

}
//begin ,,,,,,,,,,,,,,,,,,,,,,
startmenu();





async function multimes_getAccountInfo(web3pub_account) {
  let retry_times = 4;
  let account;
  while (retry_times > 0) {
    // obj_transaction = await swap_connection.getAccountInfo(sign, { commitment: "confirmed", maxSupportedTransactionVersion: 0 });
    account = await swap_connection.getAccountInfo(web3pub_account, 'confirmed');
    if (account != null) {
      break;
    }
    else {
      retry_times--;
      await sleep(500);
      continue;
    }
  }
  return account
}




async function formatAmmKeysById(str_ammid) {

  let account = await multimes_getAccountInfo(new PublicKey(str_ammid));
  // swap_connection.getAccountInfo(new PublicKey(str_ammid), 'confirmed');
  if (account == null) {
    console.log(`formatAmmKeysById error str_ammid=${str_ammid}`);
    throw new Error('get id info error');
  }
  let info = LIQUIDITY_STATE_LAYOUT_V4.decode(account.data);

  let marketId = info.marketId;
  let marketAccount = await multimes_getAccountInfo(marketId);
  // swap_connection.getAccountInfo(marketId, 'confirmed');
  if (marketAccount == null) throw new Error('get market info error');
  let marketInfo = MARKET_STATE_LAYOUT_V3.decode(marketAccount.data);

  let lpMint = info.lpMint;
  let lpMintAccount = await multimes_getAccountInfo(lpMint);
  // await swap_connection.getAccountInfo(lpMint, 'confirmed');
  if (lpMintAccount == null) throw new Error('get lp mint info error');
  const lpMintInfo = SPL_MINT_LAYOUT.decode(lpMintAccount.data);

  return {
    id: str_ammid,
    baseMint: info.baseMint.toString(),
    quoteMint: info.quoteMint.toString(),
    lpMint: info.lpMint.toString(),
    baseDecimals: info.baseDecimal.toNumber(),
    quoteDecimals: info.quoteDecimal.toNumber(),
    lpDecimals: lpMintInfo.decimals,
    version: 4,
    programId: account.owner.toString(),
    authority: Liquidity.getAssociatedAuthority({ programId: account.owner }).publicKey.toString(),
    openOrders: info.openOrders.toString(),
    targetOrders: info.targetOrders.toString(),
    baseVault: info.baseVault.toString(),
    quoteVault: info.quoteVault.toString(),
    withdrawQueue: info.withdrawQueue.toString(),
    lpVault: info.lpVault.toString(),
    marketVersion: 3,
    marketProgramId: info.marketProgramId.toString(),
    marketId: info.marketId.toString(),
    marketAuthority: Market.getAssociatedAuthority({ programId: info.marketProgramId, marketId: info.marketId }).publicKey.toString(),
    marketBaseVault: marketInfo.baseVault.toString(),
    marketQuoteVault: marketInfo.quoteVault.toString(),
    marketBids: marketInfo.bids.toString(),
    marketAsks: marketInfo.asks.toString(),
    marketEventQueue: marketInfo.eventQueue.toString(),
    lookupTableAccount: PublicKey.default.toString()
  }
}



function sleep(ms) {
  return new Promise(resolve => setTimeout(resolve, ms));
};
function accDiv(arg1, arg2) {
  if (!arg1 || !arg2) {
    return 0;
  }
  let num = new BigNumber(arg1).div(new BigNumber(arg2));
  //BigNumber超过20个小数位就会为0 比如 0.0000000000000000000000013406750208855472013
  if (num.toFixed() == 0) {
    num = new Decimal(arg1).div(new Decimal(arg2));
  }
  return num.toFixed();
}


function Map2PlainObject(value) {
  // Plain Text 纯文本
  if (value instanceof Map) {
    const obj = {};
    for (const [key, val] of value.entries()) {
      obj[key] = Map2PlainObject(val);
    }
    return obj;
  }
  if (value instanceof Set) {
    return Array.from(value).map(Map2PlainObject);
  }
  if (Array.isArray(value)) {
    return value.map(Map2PlainObject);
  }
  if (value instanceof Date) {
    return value.toISOString();
  }

  if (typeof value === 'object') {
    const obj = {};
    for (const key in value) {
      if (Object.hasOwnProperty.call(value, key)) {
        obj[key] = Map2PlainObject(value[key]);
      }
    }
    return obj;
  }
  return value;
};

function makedirpath(mkpath) {
  if (!fs.existsSync(mkpath)) {
    fs.mkdirSync(mkpath);
  }
}


function guid() {
  return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
    var r = Math.random() * 16 | 0, v = c == 'x' ? r : (r & 0x3 | 0x8);
    return v.toString(16);
  });
}
